#include "winmain1.cpp"
#include <math.h>
#include <stdlib.h>

//    .
//        
// - ,     .
void DrawBezier(HDC hdc, vector pts[], int kol)
{
	double t;	// ,        : t = [0,...,1].

	HPEN hPen;	//  ,     
				//        , 
				//  ,    .

	POINT np = {0, 0};	// ,        CalcBezierCurve.
	vector q[20];
	for (int j=0;j<=kol;j++) q[j]=pts[j];
	//        .
	MoveToEx(hdc, pts[0].x, pts[0].y, NULL);

	//   :  ,  - 1 ,  .
	hPen = CreatePen(PS_DASH, 1, RGB(0, 10, 170));

	SelectObject(hdc, hPen); //       .

	//   ,   .
	for (int i = 0; i < kol+1; i++)
		LineTo(hdc, pts[i].x, pts[i].y);

	//   :  ,  - 2 , - .
	hPen = CreatePen(PS_SOLID, 2, RGB(200, 50, 10));

	SelectObject(hdc, hPen); //       .
	//        .
	MoveToEx(hdc, pts[0].x, pts[0].y, NULL);

	//    .
	//   t,   0  1   0.3 (     )
	//       ,     .
	for (t = 0.0; t < 1.0; t += 0.03) {
		for (j=0;j<=kol;j++) pts[j]=q[j];
		np = CalcBezierCurve(pts, t, kol);
		LineTo(hdc, np.x, np.y);
	}
	for (j=0;j<=kol;j++) pts[j]=q[j];
	LineTo(hdc, pts[kol].x, pts[kol].y);

	//      .
	SelectObject(hdc, (HPEN)GetStockObject(BLACK_PEN));
	//  ,   .
	for (i = 0; i < kol+1; i++)
		Ellipse(hdc, pts[i].x-5, pts[i].y-5, pts[i].x+5, pts[i].y+5);
}


// ,         .
//     -  
//  t,    .
POINT CalcBezierCurve(vector pts[], const double& t, int kol)
{
		int i, c;
		double p;
		POINT np;
		int n = kol;

	 c = 1;
	 for (i = 0; i <= n; i++) {
		  pts[i].x = pts[i].x * c;
		  pts[i].y = pts[i].y * c;
		  c = (n-i)*c/(i+1);
	 }
	 p = 1;
	 for (i = 0; i <= n; i++) {
		  pts[i].x = pts[i].x * p;
		  pts[i].y = pts[i].y * p;
		  p = p * t;
	 }
	 p = 1;
	 for (i = n; i >= 0; i--) {
		  pts[i].x = pts[i].x * p;
		  pts[i].y = pts[i].y * p;
		  p = p * (1-t);
	 }
	np.x = 0;
	np.y = 0;
	 for (i = 0; i <= n; i++) {
		  np.x = np.x + pts[i].x;
		  np.y = np.y + pts[i].y;
	 }
	return np;
}

// ,    ,
//     .
//          
//  - ,  .
int GetNumberOfPoint (int x, int y, vector P[], int kol)
{
	int lim = kol+1;
	//    ,
	for (int i = 0; i < lim; i++) {
		//           , 
		if ((x > P[i].x-15 && x < P[i].x+15) && (y > P[i].y-15 && y < P[i].y+15))
			//     (  ).
			return i;
	}
	//       ,   .
	return -1;
}


